; Copyright (c) 1991, Louis Marienthal, All Rights Reserved

;===
PROC UK_Main ()
    ;==========

WHILE true
  SWITCH
     Case edit.f and Not view.f: UK_Edit ()
     Case view.f and Not edit.f: UK_View ()
     Otherwise:     QuitLoop
  ENDSWITCH
ENDWHILE

ENDPROC
;======

;===
PROC UK_KB ()
    ;========

Echo Normal
Echo Off
SyncCursor
IF Not IsBlank (msg.a) THEN
   Message msg.a
   msg.a = ""
ENDIF
kchr = GetChar ()
SWITCH
   Case kchr > 127: ktyp = "X"
   Case kchr > 31:  ktyp = "K"
   Case kchr > 0:
      ktyp = SubStr (plus.s, kchr, 1)          ; types for + keycodes
   Otherwise:
      ktyp = SubStr (minus.s, 1 - kchr, 1)     ; types for - keycodes & 0
      IF ktyp = "q" THEN
         UK_CtrlKey ()
      ENDIF
ENDSWITCH

ENDPROC
;======

;===
PROC UK_Edit ()
    ;==========
Private ktyp

ImageRights
UK_FldPmpt ()
WHILE edit.f
   UK_KB ()
   SWITCH
      Case ktyp = "K":      IF disp.f THEN
                               msg.a = "Form Is Display Only"
                               Loop
                            ENDIF
                            KeyPress kchr
                            IF a1.f
                            and (kchr = 32 or Not IsBlank ([]))
                            and autoe.f THEN
                               UK_Enter ()
                            ENDIF
      Case ktyp = "m":      UK_MoveF ()
      Case ktyp = "M" and (mult.f or mastl.f):
                            UK_MoveL ()
      Case ktyp = "F":      UK_Cmd ()
      Otherwise:            Beep            ; => ktyp = "X"
   ENDSWITCH
ENDWHILE

ENDPROC
;======

;===
PROC UK_View ()
    ;==========
Private todo, ktyp

ImageRights ReadOnly
newrec.f = false
UK_FldPmpt ()
WHILE view.f
   recn.n = RecNo ()
   UK_KB ()
   SWITCH
      Case ktyp = "F":      UK_Cmd ()
      Case ktyp = "m":      UK_MoveF ()
      Case ktyp = "M" and (mult.f or mastl.f):
                            UK_MoveL ()
      Case ktyp = "M" and mastx.f:
                            UK_MoveU ()
      Case ktyp = "K":      Beep
                            msg.a = "Cannot Change Field in View Mode"
      Otherwise:            Beep            ; ==> ktyp = "X"
   ENDSWITCH
ENDWHILE

ENDPROC
;======

;===
PROC UK_Field ()
    ;===========

IF pos.n <> pos_n THEN
   grp_a = SubStr (group.s, pos_n, 1)
   IF grp.a <> grp_a THEN
      grp.a = grp_a                        ; set new group
      grp.n = Asc (grp.a) - 64
      path_a = SubStr (path.s, pos_n, 1)
      IF path.a <> path_a THEN
         path.a = path_a                   ; set new path
         path.n = Asc (path.a) - 96
         pathnam.a = path.r [path.n]
         MoveTo pathnam.a                  ; and move to it
         pkeys.n = NKeyFields (pathnam.a)
         IF uk.bor.f THEN
            KAS_BOR ()
         ELSE
            uk.bor.f = true
         ENDIF
         UK_PathPmpt ()
      ENDIF
   ENDIF
   pos.n = pos_n                           ; set new pos
   UK_Pos ()                               ; move
   UK_FldPmpt ()                           ; set prompts and call prep
ELSE
   Beep
   save.x = []
ENDIF

ENDPROC
;======

;===
PROC UK_Pos ()
    ;=========

MoveTo Field fld.r [pos.n]
save.x = []

ENDPROC
;======

;===
PROC UK_NewRec ()                           ; given pos.n
    ;============                           ; get 1st pos
                                            ; of same path
path_a = SubStr (path.s, pos.n, 1)
pos_n = Search (path_a, path.s)
IF path.a = path_a THEN
   KAS_BOR ()
ENDIF
UK_Field ()

ENDPROC
;======

;===
PROC UK_NewTop ()
    ;============
Private x

FOR x FROM 1 TO pmax.n                      ; reset px34.r
   px34.r [x] = pmin.r [x]                  ; so that pos from pressing
ENDFOR                                      ; F3/F4 are path mins
path_a = SubStr (path.s, 1, 1)
IF path.a = path_a THEN
   KAS_BOR ()
ENDIF
pos_n = 1
UK_Field ()

ENDPROC
;======

;===
PROC UK_Cmd ()
    ;=========
Private todo

SWITCH
   Case kchr = 13:     ; Enter    -- return if Not edit.f
                       UK_Enter ()
   Case kchr <= -59
    and kchr >= -68:   ; F1 thru F10
                       todo = "UK_F" + StrVal (-kchr-58)
                       ExecProc todo
   Case kchr = -112:   ; Alt-F9
                       UK_F9New ()
   Case kchr = 21:     ; Ctrl-U
                       UK_UnDo ()
   Case kchr = -108    ; Alt-F5 or Ctrl-F
     or kchr = 6:      Keypress kchr  ; Field View
                       UK_FV ()
   Case kchr = 4:      ; Ctrl-D   -- return if Not edit.f
                       UK_Ditto ()
   Case kchr = 26      ; Ctrl-Z or Alt-Z
      or kchr = -44:   UK_Zoomer ()
   Case kchr = -104    ; Alt-F1 or Alt-H
      or kchr = -35:   UK_SelHelp ()
   Case kchr <= -84
    and kchr >= -103:  ; ShftF1 thru CtrlF10
                       IF SubStr (mask.a, -kchr-83, 1) = "y" THEN
                          IF kchr > -94 THEN
                             todo = "KAS_ShftF" + StrVal (-kchr-83)
                          ELSE
                             todo = "KAS_CtrlF" + StrVal (-kchr-93)
                          ENDIF
                          ExecProc todo
                       ELSE
                          Beep
                       ENDIF
   Otherwise:          Beep
ENDSWITCH

ENDPROC
;======

;===
PROC UK_MoveF ()
    ;===========

pos_n = pos.n
IF edit.f and [] <> save.x THEN
   [] = save.x
ENDIF
SWITCH                   ; basic field moves within group
    Case kchr = -72:     UK_Up ()                  ; Up
    Case kchr = -80:     UK_Down ()                ; Dn
    Case kchr = -75:     UK_Left ()                ; Left
    Case kchr = -77:     UK_Right ()               ; Right
    Case kchr =  9:      UK_Tab ()                 ; Tab
    Case kchr = -15:     UK_RevTab ()              ; Rev-Tab
    Case kchr = 260:     pos_n = pmin.r [path.n]   ; MinPos
    Case kchr = 261:     pos_n = pmax.r [path.n]   ; MaxPos
ENDSWITCH
IF ktyp = "m" THEN       ; if Up/Dn in multi-line form
   UK_Field ()           ; ktyp changed to "M"
ENDIF

ENDPROC
;======

;===
PROC UK_MoveU ()                       ; vu Mode only
    ;===========                       ; does record moves for master
Private newrec.f, fx.a

newrec.f = true
fx.a = form.a
SWITCH
    Case kchr = 270                    ; RecUp
     and Not AtFirst ():  Skip -1
    Case kchr = 271                    ; RecDn
     and Not AtLast ():   Skip 1
    Case kchr = 272                    ; ScrlUp
     and Not AtFirst ():  Skip -5
    Case kchr = 273                    ; ScrlDn
     and Not AtLast ():   Skip 5
    Case kchr = 262                    ; MinRec
      and Not AtFirst (): Home
    Case kchr = 263                    ; MaxRec
      and Not AtLast ():  End
    Case AtFirst () and                ; RecUp
     (kchr = 270 or                    ; ScrlUp
      kchr = 272 or                    ; MinRec
      kchr = 262):        Beep
                          msg.a = "First Record"
                          newrec.f = false
    Case AtLast () and                 ; RecDn
     (kchr = 271 or                    ; ScrlDn
      kchr = 273 or                    ; MaxRec
      kchr = 263):        Beep
                          msg.a = "Last Record"
                          newrec.f = false
    Otherwise:            Beep
ENDSWITCH

IF newrec.f THEN
   KAS_GetForm ()                         ; possible new form type
   IF fx.a <> form.a THEN                 ; possible new first field
      UK_NewTop ()
   ELSE
      KAS_BOR ()                          ; same field, different record
      save.x = []
   ENDIF
ENDIF

ENDPROC
;======

;===                                      ; moves for forms linked 1-M
PROC UK_MoveL ()                          ; and unlinked forms
    ;===========                          ; which are functionally multirecord

IF AtFirst () and (kchr = 270             ; RecUp
               or kchr = 272              ; ScrlUp
               or kchr = 262) THEN        ; MaxRec
   Beep
   msg.a = "First Record"
   Return                                 ; can't move up
ENDIF
IF AtLast () and ((kchr = 271 and Not edit.f)       ; RecDn
              or kchr = 273                         ; ScrlDn
              or kchr = 263) THEN                   ; MinRec
   Beep
   msg.a = "Last Record"
   Return                                 ; can't move down
ENDIF                                     ; except in ed mode,
                                          ; now, move is possible
UK_FldChk ()
IF Not RetVal THEN                        ; these test return True
   Return                                 ; in View Mode
ENDIF
UK_RecChk (false)
IF Not RetVal THEN
   Return
ENDIF

SWITCH
   Case kchr = 270:        CtrlPgUp       ; RecUp
   Case kchr = 271
    and Not AtLast ():     CtrlPgDn       ; RecDn
   Case kchr = 271
    and edit.f:            CtrlEnd        ; => AtLast
                           Enter          ; force new line
   Case kchr = 272:        PgUp           ; ScrlUp
   Case kchr = 273:        PgDn           ; ScrlDn
   Case kchr = -82
    and edit.f:            KeyPress kchr  ; Ins
   Case kchr = 262                        ; MinRec
    and Not AtFirst ():    Home
   Case kchr = 263                        ; MaxRec
    and Not AtLast ():     End
   Otherwise:              Beep
ENDSWITCH

IF RecordStatus ("New") THEN
   UK_NewRec ()
ELSE
   KAS_BOR ()
   save.x = []                            ; same field, different record
ENDIF

ENDPROC
;======

;===
PROC UK_Enter ()
    ;===========

pos_n = pos.n
UK_FldChk ()                             ; returns True in View Mode
IF Not RetVal THEN
   Return
ENDIF

SWITCH
   ;=> mult or not, either mode, not last pos on path
   Case pos.n < pmax.r [path.n]:
      pos_n = pos.n + 1

   ;=> not mult, either mode, last pos on ANY path
   Case not mult.f and pos.n = fmax.n:
      Beep
      Return

   ;=> not mult, edit mode, last pos on path
   Case not mult.f and edit.f:
      UK_RecChk (false)
      IF Not RetVal THEN
         Return
      ENDIF
      pos_n = pos.n + 1

   ;=> not mult, view mode, last pos on path
   Case not mult.f:
      pos_n = pos.n + 1

   ;=> mult, edit mode, last pos on path
   Case mult.f and edit.f:
      UK_RecChk (false)
      IF Not RetVal THEN
         Return
      ENDIF
      Enter
      pos_n = pmin.r [path.n]

   ;=> mult, view mode, last pos on path, not last record
   Case mult.f and not AtLast ():
      Enter
      pos_n = pmin.r [path.n]

   ;=> mult, view mode, last pos on path, last record
   Otherwise:
      Beep
      Return
ENDSWITCH
UK_Field ()

ENDPROC
;======

;===
PROC UK_F1 ()   ; lookup help
    ;========
Private kchr

IF SubStr (luh.s, pos.n, 1) = "n" THEN
   Beep
   msg.a = "No Lookup Help Defined by Specification"
   Return false
ENDIF

Help

IF HelpMode () <> "LookupHelp" THEN
   Beep
   msg.a = "Lookup Help Defined But Not Available"
   Esc
   Return false
ENDIF

ImageRights ReadOnly
Prompt ph1.a, ph2.a
WHILE true
   UK_KB ()
   SWITCH
       Case kchr = -77  ; Right
         or kchr = -72  ; Up
         or kchr = -80  ; Dn
         or (kchr = -75 ; Left              ; allow moves in Lookup Table
         and ColNo () > 2):
                        KeyPress kchr
       Case kchr = 260: ; MinPos
                        CtrlHome
                        Right
       Case kchr = 261: ; MaxPos
                        CtrlEnd
       Case kchr = 262: ; MinRec
                        Home
       Case kchr = 263: ; MaxRec
                        End
       Case kchr = 270: ; RecUp
                        Skip -5
       Case kchr = 271: ; RecDn
                        Skip 5
       Case kchr = 272: ; ScrlUp
                        PgUp
       Case kchr = 273: ; ScrlDn
                        PgDn
       Case kchr = 26   ; Ctrl-Z or Alt-Z
         or kchr = -44: UK_Zoomer ()
       Case kchr = -60  ; F2
         or kchr = 27:  ; Esc
                        ImageRights
                        QuitLoop
       Otherwise:       Beep
   ENDSWITCH
ENDWHILE
IF kchr = -60 and not disp.f and edit.f THEN
   Keypress kchr
   ReSyncKey                            ; show results of lookup
   ec.n = ErrorCode ()
   IF ec.n = 53 THEN
      Beep
      msg.a = "Record with Same Key(s) Already on File"
      Return false
   ENDIF
   IF autoe.f THEN                      ; if F2 loads field, do what
      UK_Enter ()                       ; regular ENTER would do
   ENDIF
ELSE
   IF kchr = -60 THEN
      IF Not edit.f THEN
         Beep
         msg.a = "In View Mode, Lookup for Info Only"
         ImageRights ReadOnly
      ENDIF
      IF disp.f THEN
         Beep
         msg.a = "Form Is Display Only"
      ENDIF
   ENDIF
   Esc
   ReSyncKey
   Prompt pmt1.a, pmt2.a                ; show prompts calculated for field
ENDIF

ENDPROC
;======

;===
PROC UK_F2 ()   ; ok/file
    ;========
Private g

IF Not edit.f THEN
   Beep
   Return
ENDIF
UK_FldChk ()
IF Not RetVal THEN
   Return
ENDIF
UK_RecChk (false)                            ; check for non unit master
IF Not RetVal THEN
   Return
ENDIF

IF Not mastl.f THEN
   FOR t FROM 1 TO pmax.n
      IF path.r [t] = tablnam.a THEN
         path_a = SubStr (path.s, t , 1)     ; master table alfa code
         pos_n = Search (path_a, path.s)     ; first pos for this alfa
         QuitLoop
      ENDIF
   ENDFOR
   UK_Field ()
   UK_RecChk (true)
   IF Not RetVal THEN
      Return
   ENDIF
ENDIF

IF newrec.f THEN
   MoveTo tablnam.a
   End                                ; CtrlEnd/Enter will work
   CtrlEnd                            ; maybe posted and not at EOF
   Enter
   UK_NewTop ()
ELSE                                  ; modify from View
   msg.a = "Modified Record Filed; Back in View Mode"
   edit.f = false                     ; back to View mode
   view.f = true
ENDIF

ENDPROC
;======

;===
PROC UK_F3 ()   ; prior group
    ;========

IF path.n = 1 THEN
   path_n = pmax.n
ELSE
   path_n = path.n - 1
ENDIF
UK_F34 ()

ENDPROC
;======

;===
PROC UK_F4 ()   ; next group
    ;========

IF path.n = pmax.n THEN
   path_n = 1
ELSE
   path_n = path.n + 1
ENDIF
UK_F34 ()

ENDPROC
;======

;===
PROC UK_F34 ()
    ;=========

UK_FldChk ()                          ; tests return True in View Mode
IF Not RetVal THEN
   path_n = path.n
   Return false
ENDIF
UK_RecChk (false)
IF Not RetVal THEN
   path_n = path.n
   Return false
ENDIF

px34.r [path.n] = pos.n               ; record exit from old path
pos_n = px34.r [path_n]               ; new pos is prior exit from new path
UK_Field ()

ENDPROC
;======

;===
PROC UK_F5 ()   ; Set View mode
    ;========

SWITCH
   Case Not edit.f:
      Beep
   Case AtFirst () and AtLast ():
      Beep
      msg.a = "Only One Record; Nothing to Review"
   Case (mastx.f or mastl.f)
    and RecordStatus ("New") and Not RecordStatus ("Modified"):
      CtrlPgUp
      edit.f = false
      view.f = true
      msg.a = "View Mode: Last Master Record"
      KAS_GetForm ()
      UK_NewTop ()
   Otherwise:
      Beep
      msg.a = "View Mode from New Unmodified Form Only"
ENDSWITCH

ENDPROC
;======

;===
PROC UK_F8 ()   ; clear/delete
    ;========

IF disp.f THEN
   msg.a = "Form Is Display Only"
   Return
ENDIF
IF Not RecordStatus ("New") THEN           ; get confirm if not new
   UK_DelOK ()
   IF Not RetVal THEN
      Return
   ELSE
      RetVal = true                        ; initialize RetVal
      KAS_DelR ()                          ; extra processing defined
      IF Not RetVal THEN                   ; in ap proc
         Return false
      ENDIF
   ENDIF
ENDIF
ImageRights

IF mastx.f THEN                            ; maybe embedded forms
   UK_UMF8 ()                              ; maybe delete one and only rec
   UK_NewTop ()
ELSE
   Beep
   Del                                     ; simple case
   UK_NewRec ()
ENDIF
IF Not edit.f THEN
   ImageRights ReadOnly
ENDIF

ENDPROC
;======

;===
PROC UK_F9 ()   ; edit this record
    ;========

IF edit.f THEN
   Beep
ELSE
   edit.f = true
   view.f = false
   msg.a = "Edit Mode"
   Beep
ENDIF

ENDPROC
;======

;===
PROC UK_F9New ()   ; edit new record
    ;===========

IF edit.f THEN
   Beep
ELSE
   MoveTo tablnam.a                       ; move to master so that
   ImageRights                            ; so that CtrlEnd/Enter will work
   End                                    ; permit new record
   CtrlEnd
   Enter
   newrec.f = true
   edit.f = true                          ; new master form will be
   view.f = false                         ; same formtype as form
   UK_NewTop ()                           ; where F7 pressed
ENDIF

ENDPROC
;======

;===
PROC UK_F10 ()
    ;=========

SWITCH
   Case view.f:
      ; fall through to KAS_EOJ
   Case (mastx.f or mastl.f)
    and RecordStatus ("New") and Not RecordStatus ("Modified"):
      ; fall through to KAS_EOJ
   Otherwise:
      Beep
      msg.a = "End of Job from View Mode or Blank Master Form Only"
      Return
ENDSWITCH
RetVal = true                       ; initialize RetVal
KAS_EOJ ()                          ; extra processing defined in ap proc
IF RetVal THEN
   DO_IT!
   view.f = false                   ; UK_Main quits when view.f and edit.f
   edit.f = false                   ; are both false
ENDIF                               ; if not RetVal then Return

ENDPROC
;======

;===
PROC UK_FldChk ()
    ;============

IF view.f THEN
   Return true
ENDIF
IF Not IsValid () THEN                ; re Paradox ValChecks
   Enter
   msg.a = Window ()
   Return false
ENDIF
IF IsBlank ([]) and SubStr (rqd.s, pos.n, 1) = "y" THEN
   Beep
   msg.a = "Required Field"
   Return false
ENDIF
IF SubStr (luh.s, pos.n, 1) = "y" THEN
   ReSyncKey                          ; display result of lookup
ENDIF
IF SubStr (pstp.s, pos.n, 1) = "y" THEN
   todo = "KAS_Pstp_" + StrVal (pos.n)
   RetVal = true                      ; initialize RetVal
   ExecProc todo                      ; do anything defined in ap proc
   IF Not RetVal THEN                 ; may be set to false in KAS proc
      Return false                    ; ap proc returned problem
   ENDIF                              ; return false to calling proc
ENDIF
Return true

ENDPROC
;======

;===
PROC UK_RecChk (mchk.f)                   ; if mchk.f, then ok to do
    ;==================                   ; rdqfld on unit master

IF view.f THEN
   Return true
ENDIF
UK_KeyChk ()
IF Not RetVal THEN
   Return false
ENDIF
IF Not mastx.f or (mastx.f and mchk.f) THEN
   UK_RqdFld ()                           ; do RqdFld on master unit form
   IF Not RetVal THEN                     ; only for F2; reason:
      Return false                        ; master unit form can be
   ENDIF                                  ; segmented whereby enter sequence
ENDIF                                     ; exits master leaving rqd field
RetVal = true                             ; in future segment
KAS_EOR ()
IF Not RetVal THEN
   Return false
ENDIF

ENDPROC
;======

;===
PROC UK_RqdFld ()
    ;============
Private f, px.a

IF RecordStatus ("New") and Not RecordStatus ("Modified") THEN
   Return true
ENDIF
px.a = SubStr (path.s, pos.n, 1)              ; path alfa for this pos
FOR f FROM 1 TO fmax.n
   IF SubStr (rqd.s, f, 1) = "y" and
      SubStr (path.s, f, 1) = px.a THEN       ; required and same path
        MoveTo Field fld.r [f]
        IF IsBlank ([]) THEN
           Beep
           msg.a = "Required Field"
           pos_n = f
           UK_Field ()                        ; go to bad pos
           Return false
        ENDIF
   ENDIF
ENDFOR
UK_Pos ()                                     ; return to original pos
Return true

ENDPROC
;======

;===
PROC UK_KeyChk ()
    ;============
Private ec.n, xrec.r

SWITCH
   Case pkeys.n = 0 or tkeys.n = 0 or disp.f or linkg.f or linko.f:
      Return true
   Case mastx.f or mastl.f or linku.f:       ; master or keyed unlinked
      UK_BlankKey (1, tkeys.n)
      IF RetVal THEN
         Beep
         msg.a = "Cannot Move Off Record with Blank Keys"
         Return false
      ENDIF
      ReSyncKey                              ; pseudo-post
      ec.n = ErrorCode ()
      UK_Pos ()                              ; reset cursor ?
      IF ec.n = 53 THEN
         Beep
         msg.a = "Record with Same Key(s) Already on File"
         Return false
      ENDIF
      Return true
   Case linkm.f:                             ; linked 1-M
      UK_BlankKey (tkeys.n + 1, pkeys.n)
      IF RetVal THEN                         ; key is blank
         IF RecordStatus ("New") THEN
            IF RecordStatus ("Modified") THEN
               Beep                          ; deleted modified line
               msg.a = "Cleared Record with Blank Key(s)"
               Del                           ; delete line
               IF AtLast () THEN             ; substitute blank
                  CtrlEnd                    ; for deleted record
                  Enter
               ELSE
                  Down
                  Ins
               ENDIF
               UK_Pos ()
               Return false
            ENDIF
         ELSE
            Beep                             ; key was changed to blank ?
            msg.a = "Cannot Move Off Existing Record with Blank Keys"
            Return false
         ENDIF
      ENDIF
      IF Not RecordStatus ("New") and Not RecordStatus ("Modified") THEN
         Return true                         ; just passing thru -- no EOR
      ENDIF
      KeyLookUp
      ec.n = ErrorCode ()
      IF ec.n = 56 THEN
         Return true                         ; new record, new key
      ELSE
         KeyLookUp                           ; toggle back to entry
         IF Not AtLast () THEN               ; this is either record
            Del                              ; just modified or record
            Ins                              ; causing error
         ELSE
            Del
            CtrlEnd
            Enter
         ENDIF
         CopyFromArray xrec.r                ; array from blank-key test
         UK_Pos ()                           ; reset cursor
         KeyLookUp
         ec.n = ErrorCode ()
         IF ec.n = 56 THEN
            Return true                      ; old record modified
         ELSE                                ; unique key
            KeyLookUp                        ; restore to new entry
            Beep                             ; that caused trouble
            msg.a = "Record with Same Key(s) Already on File"
            Return false
         ENDIF
      ENDIF
ENDSWITCH

ENDPROC
;======

;===
PROC UK_BlankKey (k1, k2)          ; k1 = 1 or
    ;====================          ; k1 = 1 + number of keys in master
Private x                          ; k2 = number of keys in current path

k1 = k1 + 1
k2 = k2 + 1
CopyToArray xrec.r                          ; number of fields to test
FOR x FROM k1 TO k2                         ; is inclusive difference
   IF Not IsBlank (xrec.r [x]) THEN         ; start at 2 for master
      Return false                          ; start at 2+ master keys
   ENDIF                                    ; for other table
ENDFOR
Return true

ENDPROC
;======
